# talos-aclient
FastAPI Best Architecture

This Python package is automatically generated by the [OpenAPI Generator](https://openapi-generator.tech) project:

- API version: 0.0.1
- Package version: 1.0.0
- Generator version: 7.8.0
- Build package: org.openapitools.codegen.languages.PythonClientCodegen

## Requirements.

Python 3.7+

## Installation & Usage
### pip install

If the python package is hosted on a repository, you can install directly using:

```sh
pip install git+https://github.com/GIT_USER_ID/GIT_REPO_ID.git
```
(you may need to run `pip` with root permission: `sudo pip install git+https://github.com/GIT_USER_ID/GIT_REPO_ID.git`)

Then import the package:
```python
import talos_aclient
```

### Setuptools

Install via [Setuptools](http://pypi.python.org/pypi/setuptools).

```sh
python setup.py install --user
```
(or `sudo python setup.py install` to install the package for all users)

Then import the package:
```python
import talos_aclient
```

### Tests

Execute `pytest` to run the tests.

## Getting Started

Please follow the [installation procedure](#installation--usage) and then run the following:

```python

import talos_aclient
from talos_aclient.rest import ApiException
from pprint import pprint

# Defining the host is optional and defaults to http://localhost
# See configuration.py for a list of all supported configuration parameters.
configuration = talos_aclient.Configuration(
    host = "http://localhost"
)



# Enter a context with an instance of the API client
async with talos_aclient.ApiClient(configuration) as api_client:
    # Create an instance of the API class
    api_instance = talos_aclient.DatasetApi(api_client)
    add_resource_to_dataset_request = talos_aclient.AddResourceToDatasetRequest() # AddResourceToDatasetRequest | 

    try:
        # Add Resource
        api_response = await api_instance.add_resource(add_resource_to_dataset_request)
        print("The response of DatasetApi->add_resource:\n")
        pprint(api_response)
    except ApiException as e:
        print("Exception when calling DatasetApi->add_resource: %s\n" % e)

```

## Documentation for API Endpoints

All URIs are relative to *http://localhost*

Class | Method | HTTP request | Description
------------ | ------------- | ------------- | -------------
*DatasetApi* | [**add_resource**](docs/DatasetApi.md#add_resource) | **POST** /v1/talos/dataset/add_resource | Add Resource
*DatasetApi* | [**clone_dataset**](docs/DatasetApi.md#clone_dataset) | **POST** /v1/talos/dataset/clone | Clone Dataset
*DatasetApi* | [**create_dataset**](docs/DatasetApi.md#create_dataset) | **POST** /v1/talos/dataset/create | Create Dataset
*DatasetApi* | [**delete_dataset**](docs/DatasetApi.md#delete_dataset) | **POST** /v1/talos/dataset/delete | Delete Dataset
*DatasetApi* | [**delete_dataset_resource**](docs/DatasetApi.md#delete_dataset_resource) | **POST** /v1/talos/dataset/delete_resource | Delete Dataset Resource
*DatasetApi* | [**enable_dataset_resource**](docs/DatasetApi.md#enable_dataset_resource) | **POST** /v1/talos/dataset/enable_resource | Enable Dataset Resource
*DatasetApi* | [**get_dataset**](docs/DatasetApi.md#get_dataset) | **POST** /v1/talos/dataset/get | Get Dataset
*DatasetApi* | [**list_dataset**](docs/DatasetApi.md#list_dataset) | **POST** /v1/talos/dataset/list | List Dataset
*DatasetApi* | [**list_resources**](docs/DatasetApi.md#list_resources) | **POST** /v1/talos/dataset/list_resources | List Resources
*DatasetApi* | [**list_rows**](docs/DatasetApi.md#list_rows) | **POST** /v1/talos/dataset/list_rows | List Rows
*DatasetApi* | [**refresh_dataset**](docs/DatasetApi.md#refresh_dataset) | **POST** /v1/talos/dataset/refresh | Refresh Dataset
*DatasetApi* | [**refresh_resource**](docs/DatasetApi.md#refresh_resource) | **POST** /v1/talos/dataset/refresh_resource | Refresh Resource
*DatasetApi* | [**update_dataset**](docs/DatasetApi.md#update_dataset) | **POST** /v1/talos/dataset/update | Update Dataset
*DefaultApi* | [**health**](docs/DefaultApi.md#health) | **GET** /health | Health
*ResourceApi* | [**create_resource**](docs/ResourceApi.md#create_resource) | **POST** /v1/talos/resource/create | Create Resource
*ResourceApi* | [**delete_resource**](docs/ResourceApi.md#delete_resource) | **POST** /v1/talos/resource/delete | Delete Resource
*ResourceApi* | [**get_resource**](docs/ResourceApi.md#get_resource) | **POST** /v1/talos/resource/get | Get Resource
*ResourceApi* | [**get_resource_image**](docs/ResourceApi.md#get_resource_image) | **POST** /v1/talos/resource/get_image | Get Resource Image
*ResourceApi* | [**list_resource**](docs/ResourceApi.md#list_resource) | **POST** /v1/talos/resource/list | List Resource
*SegmentApi* | [**delete_segments**](docs/SegmentApi.md#delete_segments) | **POST** /v1/talos/segment/delete | Delete Segments
*SegmentApi* | [**list_segments**](docs/SegmentApi.md#list_segments) | **POST** /v1/talos/segment/list | List Segments
*SegmentApi* | [**update_segment**](docs/SegmentApi.md#update_segment) | **POST** /v1/talos/segment/update | Update Segment
*VectorApi* | [**vector_retrieve**](docs/VectorApi.md#vector_retrieve) | **POST** /v1/talos/vector/retrieve | Vector Retrieve


## Documentation For Models

 - [AddResourceToDatasetRequest](docs/AddResourceToDatasetRequest.md)
 - [CloneDatasetRequest](docs/CloneDatasetRequest.md)
 - [Column](docs/Column.md)
 - [CreateDatasetRequest](docs/CreateDatasetRequest.md)
 - [CreateDatasetResponse](docs/CreateDatasetResponse.md)
 - [CreateDatasetResponseItem](docs/CreateDatasetResponseItem.md)
 - [CreateResourceRequest](docs/CreateResourceRequest.md)
 - [CreateResourceRespItem](docs/CreateResourceRespItem.md)
 - [CreateResourceResponse](docs/CreateResourceResponse.md)
 - [Data](docs/Data.md)
 - [DataType](docs/DataType.md)
 - [Dataset](docs/Dataset.md)
 - [DeleteDatasetRequest](docs/DeleteDatasetRequest.md)
 - [DeleteDatasetResourceRequest](docs/DeleteDatasetResourceRequest.md)
 - [DeleteResourceRequest](docs/DeleteResourceRequest.md)
 - [DeleteSegmentRequest](docs/DeleteSegmentRequest.md)
 - [ElasticsearchAnalyzer](docs/ElasticsearchAnalyzer.md)
 - [EmbeddingModel](docs/EmbeddingModel.md)
 - [EnableResourceRequest](docs/EnableResourceRequest.md)
 - [EnumCeleryQueue](docs/EnumCeleryQueue.md)
 - [GetDatasetRequest](docs/GetDatasetRequest.md)
 - [GetDatasetResponse](docs/GetDatasetResponse.md)
 - [GetResourceImageRequest](docs/GetResourceImageRequest.md)
 - [GetResourceImageResponse](docs/GetResourceImageResponse.md)
 - [GetResourceRequest](docs/GetResourceRequest.md)
 - [GetResourceResponse](docs/GetResourceResponse.md)
 - [HTTPValidationError](docs/HTTPValidationError.md)
 - [IndexConfigInput](docs/IndexConfigInput.md)
 - [IndexConfigOutput](docs/IndexConfigOutput.md)
 - [ListDatasetRequest](docs/ListDatasetRequest.md)
 - [ListDatasetResourcesRequest](docs/ListDatasetResourcesRequest.md)
 - [ListDatasetResourcesResponse](docs/ListDatasetResourcesResponse.md)
 - [ListDatasetResponse](docs/ListDatasetResponse.md)
 - [ListResourcesRequest](docs/ListResourcesRequest.md)
 - [ListResourcesResponse](docs/ListResourcesResponse.md)
 - [ListRowsRequest](docs/ListRowsRequest.md)
 - [ListRowsResponse](docs/ListRowsResponse.md)
 - [ListSegmentsRequest](docs/ListSegmentsRequest.md)
 - [ListSegmentsResponse](docs/ListSegmentsResponse.md)
 - [OpenSearchArgs](docs/OpenSearchArgs.md)
 - [ParseConfig](docs/ParseConfig.md)
 - [ParseMethod](docs/ParseMethod.md)
 - [RefreshDatasetRequest](docs/RefreshDatasetRequest.md)
 - [RefreshDatasetResourceRequest](docs/RefreshDatasetResourceRequest.md)
 - [RelationalDBConfigInput](docs/RelationalDBConfigInput.md)
 - [RelationalDBConfigOutput](docs/RelationalDBConfigOutput.md)
 - [Resource](docs/Resource.md)
 - [ResourceContent](docs/ResourceContent.md)
 - [ResourceDataDb](docs/ResourceDataDb.md)
 - [ResourceDataFile](docs/ResourceDataFile.md)
 - [ResourceDataTable](docs/ResourceDataTable.md)
 - [ResourceDataWeb](docs/ResourceDataWeb.md)
 - [ResourceType](docs/ResourceType.md)
 - [ResponseModel](docs/ResponseModel.md)
 - [RetrieveSearchType](docs/RetrieveSearchType.md)
 - [RetrieveSegment](docs/RetrieveSegment.md)
 - [RetrieveSegmentsRequest](docs/RetrieveSegmentsRequest.md)
 - [RetrieveSegmentsResponse](docs/RetrieveSegmentsResponse.md)
 - [Segment](docs/Segment.md)
 - [StorageType](docs/StorageType.md)
 - [TableRow](docs/TableRow.md)
 - [TaskStep](docs/TaskStep.md)
 - [TransformStep](docs/TransformStep.md)
 - [UpdateDatasetRequest](docs/UpdateDatasetRequest.md)
 - [UpdateDatasetResponse](docs/UpdateDatasetResponse.md)
 - [UpdateSegmentRequest](docs/UpdateSegmentRequest.md)
 - [UpdateSegmentResponse](docs/UpdateSegmentResponse.md)
 - [ValidationError](docs/ValidationError.md)
 - [ValidationErrorLocInner](docs/ValidationErrorLocInner.md)
 - [VectorStoreArgs](docs/VectorStoreArgs.md)
 - [VectorStoreType](docs/VectorStoreType.md)


<a id="documentation-for-authorization"></a>
## Documentation For Authorization

Endpoints do not require authorization.


## Author




