# coding: utf-8

"""
    Talos

    FastAPI Best Architecture

    The version of the OpenAPI document: 0.0.1
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, StrictBool, StrictStr
from typing import Any, ClassVar, Dict, List, Optional
from talos_aclient.models.data import Data
from talos_aclient.models.enum_celery_queue import EnumCeleryQueue
from talos_aclient.models.resource_type import ResourceType
from typing import Optional, Set
from typing_extensions import Self

class CreateResourceRequest(BaseModel):
    """
    CreateResourceRequest
    """ # noqa: E501
    type: ResourceType
    dry_run: Optional[StrictBool] = False
    name: StrictStr
    data: Data
    async_mode: Optional[StrictBool] = True
    queue: Optional[EnumCeleryQueue] = None
    __properties: ClassVar[List[str]] = ["type", "dry_run", "name", "data", "async_mode", "queue"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of CreateResourceRequest from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of data
        if self.data:
            _dict['data'] = self.data.to_dict()
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of CreateResourceRequest from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "type": obj.get("type"),
            "dry_run": obj.get("dry_run") if obj.get("dry_run") is not None else False,
            "name": obj.get("name"),
            "data": Data.from_dict(obj["data"]) if obj.get("data") is not None else None,
            "async_mode": obj.get("async_mode") if obj.get("async_mode") is not None else True,
            "queue": obj.get("queue")
        })
        return _obj


